/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.deprecated;

import jp.pegasus.pivot.skin.SSCornerSkin;
import jp.pegasus.pivot.skin.SSTablePaneSkin;
import jp.pegasus.pivot.skin.SSTextAreaSkin;
import jp.pegasus.pivot.skin.ScrollPaneSkin;
import jp.pegasus.pivot.ss.SSCorner;
import jp.pegasus.pivot.ss.SSScrollPane;
import jp.pegasus.pivot.ss.SSTextArea;
import jp.pegasus.pivot.ss.tablepane.SSTablePane;
import jp.pegasus.pivot.util.SSTableViewUtil;
import org.apache.pivot.collections.Map;
import org.apache.pivot.wtk.*;
import org.apache.pivot.wtk.Label;
import org.apache.pivot.wtk.TablePane.ColumnSequence;
import org.apache.pivot.wtk.TablePane.Filler;
import org.apache.pivot.wtk.TablePane.RowSequence;
import org.apache.pivot.wtk.TextArea;
import org.apache.pivot.wtk.Window;
import org.apache.pivot.wtk.media.Drawing;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.awt.*;

@Deprecated
public class SpreadSheet2 implements Application {
    private Logger log = LoggerFactory.getLogger(SpreadSheet2.class);
    private static long L00;
    private static long L01;
    private static long L02;

    public static final int MAX_COL_NUM = 31;
    public static final int MAX_ROW_NUM = 257;
    public static final int COL_WIDTH = 71;
    public static final int COL_MAX_WIDTH = 255;
    public static final int COL_MIN_WIDTH = 16;

    public static final int HEADER_COL_WIDTH = 35;

    private Window window = null;
    private Drawing drawing = null;
    private ImageView imageView = new ImageView();
    private SSTablePane ssTablePane = null;
    private SSTablePane ssTablePaneH = null;
    private SSTablePane ssTablePaneV = null;
    private TextArea textArea = new TextArea();

    public SpreadSheet2() {
        super();
        Theme.getTheme().set(SSCorner.class, SSCornerSkin.class);
        Theme.getTheme().set(SSScrollPane.class, ScrollPaneSkin.class);
        Theme.getTheme().set(SSTablePane.class, SSTablePaneSkin.class);
        Theme.getTheme().set(SSTextArea.class, SSTextAreaSkin.class);

    }

    private void createSpreadSheet() {
        log.debug("createSpreadSheet");

//        ssTablePane = SpreadSheetTool.getSSTablePane();
//		ssTablePaneV = SpreadSheetTool.getSSTablePane();
//		ssTablePaneH = SpreadSheetTool.getSSTablePane();

//        ssTablePane.setAttribute(Attribute.TABLE, TableType.MAIN);
//		ssTablePaneV.setAttribute(Attribute.TABLE, TableType.HEADER_ROW);
//		ssTablePaneH.setAttribute(Attribute.TABLE, TableType.HEADER_COL);

        ColumnSequence ssCols = ssTablePane.getColumns();
//		ColumnSequence ssColsV = ssTablePaneV.getColumns();
//		ColumnSequence ssColsH = ssTablePaneH.getColumns();

        for (int i = 0; i < MAX_COL_NUM; i++) {
            if (i == 0) {
//                SSColumn ssCol = SpreadSheetTool.getSSColumn(HEADER_COL_WIDTH);//XXX
//				SSColumn ssColV = SpreadSheetTool.getSSColumn(HEADER_COL_WIDTH);
//				ssCol.setWidth(0);//XXX
//                ssCols.add(ssCol); //XXX
//				ssColsV.add(ssColV);
            } else {
//                SSColumn ssCol = SpreadSheetTool.getSSColumn(COL_WIDTH);
//				SSColumn ssColH = SpreadSheetTool.getSSColumn(COL_WIDTH);
//                ssCols.add(ssCol);
//				ssColsH.add(ssColH);
            }
        }

        RowSequence ssRows = ssTablePane.getRows();
//		RowSequence ssRowsV = ssTablePaneV.getRows();
//		RowSequence ssRowsH = ssTablePaneH.getRows();

        for (int row = 0; row < MAX_ROW_NUM; row++) {
            if (row == 0) {
//                SSRow ssRow = SpreadSheetTool.getSSRow();//XXX
//                Filler filler = new Filler();//XXX
//				filler.setVisible(false);//XXX
//                ssRow.add(filler);//XXX
//				SSRow ssRowV = SpreadSheetTool.getSSRow();
//				SSRow ssRowH = SpreadSheetTool.getSSRow();
                for (int col = 1; col < MAX_COL_NUM; col++) {
//					String colNameH = SpreadSheetTool.fromNumber2Alphabet(col);
//					SSCorner ssBorderH = SpreadSheetTool.getSSBorder(
//							BASE_HEADER_BACKGROUND_COLOR,
//							BASE_HEADER_BACKGROUND_COLOR,
//							HORIZONTAL_BORDER_COLOR,
//							BASE_HEADER_BACKGROUND_COLOR,
//							TableType.HEADER_COL);
//					Label labelH = SpreadSheetTool.getLabel(colNameH);
//					labelH.getStyles().put("backgroundColor", COL_HEADER_BACKGROUND_COLOR);
//					ssBorderH.setContent(labelH);
//					ssRowH.add(ssBorderH);

                    String colName = SSTableViewUtil.fromNumber2Alphabet(col);//XXX
                    Label label = getLabel(colName);//XXX
//                    label.getStyles().put("backgroundColor", COL_HEADER_BACKGROUND_COLOR);//XXX
//                    ssRow.add(label);//XXX
                }
//                ssRows.add(ssRow); //XXX
//				ssRowsV.add(ssRowV);
//				ssRowsH.add(ssRowH);
            } else {
//				SSRow ssRowV = SpreadSheetTool.getSSRowV(row);
//				SSCorner ssBorderV = SpreadSheetTool.getSSBorder(
//						BASE_HEADER_BACKGROUND_COLOR,
//						VERTICAL_BORDER_COLOR,
//						BASE_HEADER_BACKGROUND_COLOR,
//						BASE_HEADER_BACKGROUND_COLOR,
//						TableType.HEADER_ROW);
//				Label labelV = SpreadSheetTool.getLabel(row);
//				labelV.getStyles().put("backgroundColor", ROW_HEADER_BACKGROUND_COLOR);
//				ssBorderV.setContent(labelV);
//				ssRowV.add(ssBorderV);

                Label label = SpreadSheetTool.getLabel(row);//XXX
//                label.getStyles().put("backgroundColor", ROW_HEADER_BACKGROUND_COLOR);//XXX
//                SSRow ssRow = SpreadSheetTool.getSSRow();//XXX
//                ssRow.add(label);//XXX

                for (int col = 1; col < MAX_COL_NUM; col++) {

                    if (row == 1 || col == 1) {
                        Filler filler = new Filler();
//                        ssRow.add(filler);
                    }
//					Filler filler = new Filler();
//					ssRow.add(filler);
//					SSTextArea textArea = SpreadSheetTool.getSSTextArea(row, col);
//					ssRow.add(textArea);
                }
//                ssRows.add(ssRow);
//				ssRowsV.add(ssRowV);
            }
        }

//		SSTablePaneHeader ssTablePaneHeaderH = new SSTablePaneHeader();
//		ssTablePaneHeaderH.setSSTablePane(ssTablePane);
//		ssTablePaneHeaderH.setOrientation(Orientation.HORIZONTAL);
//		ssTablePaneHeaderH.setSize(1000, 30);
//
//
//		SSTablePaneHeader ssTablePaneHeaderV = new SSTablePaneHeader();
//		ssTablePaneHeaderV.setSSTablePane(ssTablePane);


//        SSScrollPane ssScrollPane =
//                SpreadSheetTool.getSSScrollPane(ssTablePane, ssTablePaneH, ssTablePaneV);
//        ssScrollPane.setLocation(30, 30);
//        ssScrollPane.setSize(30, 30);


//		scrollPane.setColumnHeader(ssTablePane);
//		ssTablePane.getParent().

//			SpreadSheetTool.getSSScrollPane(ssTablePane, ssTablePaneHeaderH, ssTablePaneHeaderV);


//		Filler filler = new Filler();//XXX
//		filler.setSize(40, 100);

//		filler.setVisible(false);//XXX
//		scrollPane.setColumnHeader(filler);

//		SSScrollPane ssScrollPane = new SSScrollPane();

//        SSCorner ssBorder = SpreadSheetTool.getSSBorder();
//        ssBorder.setContent(ssScrollPane);
//		ssBorder.setContent(ssTablePane);

        window = SpreadSheetTool.getWindow();
//        ssWindow.setContent(ssBorder);
    }

    @Override
    public void startup(Display display, Map<String, String> properties)
    throws Exception {
        createSpreadSheet();

//		ssTablePane.getSSTablePaneListeners().add(new SSTablePaneListener(){
//
//			@Override
//			public void selectedRangeAdded(SSTablePane ssTablePane,
//					int rangeStart, int rangeEnd) {
//				log.debug("");
//			}
//
//			@Override
//			public void selectedRangeRemoved(SSTablePane ssTablePane,
//					int rangeStart, int rangeEnd) {
//				log.debug("");
//			}
//
//			@Override
//			public void selectedRangesChanged(SSTablePane ssTablePane,
//					Sequence<Span> previousSelectedRanges) {
//				log.debug("");
//			}
//
//			@Override
//			public void orientationChanged(SSTablePane ssTablePane) {
//				log.debug("");
//			}
//		});

        window.open(display);
        L02 = System.currentTimeMillis();
        log.debug("execution time: {} s", (L02 - L00) / 1000.0);
    }

    @Override
    public boolean shutdown(boolean optional) {
        if (window != null) {
            window.close();
        }

        return false;
    }

    @Override
    public void suspend() {
    }

    @Override
    public void resume() {
    }

    public static void main(String[] args) {
        L00 = System.currentTimeMillis();
        DesktopApplicationContext.main(SpreadSheet2.class, args);
    }

    public Label getLabel(String colName) {
        Label label = new Label();
        label.setText(colName);
//        label.getStyles().put("font", new Font(LABEL_FONT, Font.PLAIN, LABEL_FONT_SIZE));
        label.getStyles().put("color", Color.DARK_GRAY);
        label.getStyles().put("horizontalAlignment",
        HorizontalAlignment.CENTER);
        label.getStyles().put("verticalAlignment",
        VerticalAlignment.CENTER);
        return label;
    }

}
