/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.effects;

import org.apache.pivot.wtk.Bounds;
import org.apache.pivot.wtk.effects.Decorator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.awt.*;
import java.awt.geom.AffineTransform;

public class SSHeaderBorderDecorator implements Decorator {
    private Logger log = LoggerFactory.getLogger(SSHeaderBorderDecorator.class);

    private Graphics2D graphics = null;
    private org.apache.pivot.wtk.Component component = null;
    //    private Color color = new Color(223, 223, 223, 63);
    private Color backgrondColor = new Color(255, 0, 127, 63);
    private Color borderColor = new Color(255, 0, 127, 63);

    private int selectX;
    private int selectY;
    private int selectWidth;
    private int selectHeight;

    @Override
    public Graphics2D prepare(org.apache.pivot.wtk.Component component, Graphics2D graphics) {
        this.component = component;
        this.graphics = graphics;

        graphics.setColor(backgrondColor);
        graphics.fillRect(selectX,
        selectY,
        selectWidth,
        selectHeight);

        graphics.setColor(borderColor);
        graphics.setStroke(new BasicStroke(1));
        graphics.drawRect(selectX - 1,
        selectY - 1,
        selectWidth + 1,
        selectHeight + 1);

        return graphics;
    }

    @Override
    public void update() {
        prepare(component, graphics);
    }

    @Override
    public Bounds getBounds(org.apache.pivot.wtk.Component component) {
        return new Bounds(-1, -1, component.getWidth() + 1, component.getHeight() + 1);
    }

    @Override
    public AffineTransform getTransform(org.apache.pivot.wtk.Component component) {
        return new AffineTransform();
    }

    public Bounds getSelectBounds() {
        return new Bounds(selectX, selectY, selectWidth, selectHeight);
    }

    public void setSelectBounds(Bounds selectBounds) {
        selectX = selectBounds.x;
        selectY = selectBounds.y;
        selectWidth = selectBounds.width;
        selectHeight = selectBounds.height;
    }

    public void setSelectX(int selectX) {
        this.selectX = selectX;
    }

    public void setSelectY(int selectY) {
        this.selectY = selectY;
    }

    public void setSelectWidth(int selectWidth) {
        this.selectWidth = selectWidth;
    }

    public void setSelectHeight(int selectHeight) {
        this.selectHeight = selectHeight;
    }

    public Color getBackgrondColor() {
        return backgrondColor;
    }

    public void setBackgrondColor(Color backgrondColor) {
        this.backgrondColor = backgrondColor;
    }

    public Color getBorderColor() {
        return borderColor;
    }

    public void setBorderColor(Color borderColor) {
        this.borderColor = borderColor;
    }
}
