/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.pivot.sample.SampleCreator;
import jp.pegasus.pivot.util.SSTableViewUtil;
import org.apache.pivot.wtk.Accordion;
import org.apache.pivot.wtk.Insets;

import java.awt.*;

public class SSAccordionFactory {

    public static Accordion createAccordion() {

        Accordion accordion = new Accordion();
        accordion.getStyles().put("buttonPadding", new Insets(0, 2, 0, 0));
        accordion.getStyles().put("padding", new Insets(2));
        accordion.setPreferredWidth(100);
        Color acColor1 = new Color(230, 255, 255, 255);
        Color acColor2 = new Color(255, 255, 230, 255);
        for (int i = 1; i < 10; i++) {
            accordion.getStyles().put("buttonBackgroundColor", acColor1);

            String x = SSTableViewUtil.fromNumber2Alphabet(i);
            org.apache.pivot.wtk.Label lb = new org.apache.pivot.wtk.Label(SampleCreator.echo(x, 10));
            lb.getStyles().put("backgroundColor", acColor2);
            lb.getStyles().put("font", new Font("ＭＳ Ｐゴシック", Font.PLAIN, 11));
            Accordion.setHeaderData(lb, x);
            accordion.getPanels().add(lb);
        }

        return accordion;
    }
}
