/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.config.Location;
import jp.pegasus.log.Logger;
import jp.pegasus.pivot.ss.SSBorder;
import jp.pegasus.pivot.ss.SSCorner;
import jp.pegasus.util.JsonUtil;
import org.apache.pivot.wtk.Component;
import org.apache.pivot.wtk.ComponentMouseButtonListener;
import org.apache.pivot.wtk.ComponentMouseListener;
import org.apache.pivot.wtk.Mouse;

public class SSBorderFactory {

    public static SSBorder createBorder() {
        SSBorder border = new SSBorder();
        JsonUtil.setStyles(border, Location.BORDER);

        border.getComponentMouseButtonListeners().add(new ComponentMouseButtonListener() {

            @Override
            public boolean mouseDown(Component component, Mouse.Button button, int x, int y) {
                Logger.log.debug("");
                return false;
            }

            @Override
            public boolean mouseUp(Component component, Mouse.Button button, int x, int y) {
                return false;
            }

            @Override
            public boolean mouseClick(Component component, Mouse.Button button, int x, int y, int count) {
                return false;
            }
        });

        border.getComponentMouseListeners().add(new ComponentMouseListener() {

            @Override
            public boolean mouseMove(Component component, int x, int y) {
                return false;
            }

            @Override
            public void mouseOver(Component component) {
                Logger.log.debug("");
            }

            @Override
            public void mouseOut(Component component) {
                Logger.log.debug("");
            }
        });

//        corner.getComponentMouseButtonListeners().add(new ComponentMouseButtonListener(){
//            @Override
//            public boolean mouseDown(Component component, Mouse.Button button, int x, int y) {
//                log.debug("");
//                SSCorner corner = (SSCorner)component;
//                JsonUtil.setStyles(corner, LOCATION_SELECTED);
//                return false;
//            }
//
//            @Override
//            public boolean mouseUp(Component component, Mouse.Button button, int x, int y) {
//                log.debug("");
//                SSCorner corner = (SSCorner)component;
//                JsonUtil.setStyles(corner, LOCATION);
//                return false;
//            }
//
//            @Override
//            public boolean mouseClick(Component component, Mouse.Button button, int x, int y, int count) {
//                log.debug("");
//                return false;
//            }
//        });

        return border;
    }

    public static void setDefaultSkin(SSCorner corner) {
        JsonUtil.setStyles(corner, Location.BORDER);
    }

    public static void setSelectedSkin(SSCorner corner) {
        JsonUtil.setStyles(corner, Location.BORDER_SELECTED);
    }

}
