/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.config.Config;
import jp.pegasus.config.Location;
import jp.pegasus.pivot.ss.SSFlowPane;
import jp.pegasus.util.JsonUtil;

public class SSFlowPaneFactory {

    public static SSFlowPane createFlowPane() {
        SSFlowPane flowPane = new SSFlowPane();
        JsonUtil.setStyles(flowPane, Location.FLOW_PANE);

        flowPane.add(SSPushButtonFactory.createPushButton("1", "Save"));
        flowPane.add(SSPushButtonFactory.createPushButton("2", "Copy"));
        flowPane.add(SSPushButtonFactory.createPushButton("3", "Delete"));
        flowPane.add(SSPushButtonFactory.createPushButton("4", "Paste"));
        flowPane.setPreferredWidth(Config.FLOW_PANE_PREFERRED_WIDTH);


        return flowPane;
    }
}
