/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.config.Location;
import jp.pegasus.util.JsonUtil;
import org.apache.pivot.wtk.MenuBar;

public class SSMenuBarFactory {

    public static MenuBar createMenuBar() {
        MenuBar menuBar = new MenuBar();
        JsonUtil.setStyles(menuBar, Location.MENU_BAR);

//        ColorChooserButton colorChooserButton = new ColorChooserButton();
//        Color selectedColor = colorChooserButton.getSelectedColor();
//        colorChooserButton.setName("Color");
//        colorChooserButton.setButtonData(Color.BLACK);

        menuBar.getItems().add(SSMenuBarItemFactory.createFileMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createSeparatorMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createSearchMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createToolsMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createPreferenceMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createSeparatorMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createVersionControlMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createSeparatorMenuBarItem());
        menuBar.getItems().add(SSMenuBarItemFactory.createHelpMenuBarItem());

        return menuBar;
    }

}
