/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *     Pegasus is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     Pegasus is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.config.Config;
import jp.pegasus.config.Location;
import jp.pegasus.log.Logger;
import jp.pegasus.pivot.ss.SSPushButton;
import jp.pegasus.util.JsonUtil;
import org.apache.pivot.wtk.Button;
import org.apache.pivot.wtk.ButtonPressListener;
import org.apache.pivot.wtk.ButtonStateListener;

/**
 * Created by IntelliJ IDEA.
 * User: Kitani7
 * Date: 11/05/09
 * Time: 20:41
 * To change this template use File | Settings | File Templates.
 */
public class SSPushButtonFactory {

    public static SSPushButton createPushButton(String buttonDataKey, Object buttonData) {
        SSPushButton pushButton = new SSPushButton();
        JsonUtil.setStyles(pushButton, Location.PUSH_BUTTON);
        pushButton.setButtonData(buttonData);
        pushButton.setPreferredSize(
        Config.PUSH_BUTTON_PREFERRED_WIDTH,
        Config.PUSH_BUTTON_PREFERRED_HEIGHT);
        pushButton.setButtonDataKey(buttonDataKey);
        pushButton.setToggleButton(true);

        pushButton.getButtonPressListeners().add(new ButtonPressListener() {
            @Override
            public void buttonPressed(Button button) {
                String buttonDataKey = button.getButtonDataKey();
                Logger.log.info("buttonDataKey: {}", buttonDataKey);

            }
        });

        pushButton.getButtonStateListeners().add(new ButtonStateListener() {
            @Override
            public void stateChanged(Button button, Button.State previousState) {
                Logger.log.info("previousState: {}", previousState);
            }
        });

        return pushButton;
    }
}
