/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *     Pegasus is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     Pegasus is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.pivot.ss.SSScrollBar;
import org.apache.pivot.wtk.Orientation;

/**
 * Created by IntelliJ IDEA.
 * User: Kitani7
 * Date: 11/02/21
 * Time: 0:15
 * To change this template use File | Settings | File Templates.
 */
public class SSScrollBarFactory {

    public static SSScrollBar createScrollBar() {
        return createScrollBar(Orientation.HORIZONTAL);
    }

    public static SSScrollBar createScrollBar(Orientation orientation) {
        if (orientation == null) {
            throw new IllegalArgumentException("orientation is null");
        }

        SSScrollBar scrollBar = new SSScrollBar();
        scrollBar.setOrientation(orientation);
//        scrollBar.setScope(0, 9);

        return scrollBar;
    }


}
