/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *     Pegasus is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     Pegasus is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.config.Location;
import jp.pegasus.log.Logger;
import jp.pegasus.pivot.ss.tablepane.SSTablePane;
import jp.pegasus.util.JsonUtil;
import org.apache.pivot.wtk.Component;
import org.apache.pivot.wtk.ComponentKeyListener;
import org.apache.pivot.wtk.Keyboard;

public class SSTablePaneFactory {

    public static SSTablePane createTablePane() {
        SSTablePane tablePane = new SSTablePane();
        JsonUtil.setStyles(tablePane, Location.TABLE_PANE);

        tablePane.getComponentKeyListeners().add(new ComponentKeyListener() {
            @Override
            public boolean keyTyped(Component component, char character) {
                Logger.log.info("character: {}", character);
                return false;
            }

            @Override
            public boolean keyPressed(Component component, int keyCode, Keyboard.KeyLocation keyLocation) {
                Logger.log.info("keyCode: {}", keyCode);

                return false;
            }

            @Override
            public boolean keyReleased(Component component, int keyCode, Keyboard.KeyLocation keyLocation) {
                Logger.log.info("keyCode: {}", keyCode);
//                if (keyCode == Keyboard.KeyCode.ENTER) {
//                    Logger.log.info("ENTER");
//                    SSTablePane ssTablePane = (SSTablePane)component;
//                    SSCardPane ssCardPane = (SSCardPane)ssTablePane.getParent();
//                    SSScrollPane ssScrollPane = (SSScrollPane)ssCardPane.getParent();
//                    SSTableViewRowEditor ssTableViewRowEditor = (SSTableViewRowEditor)ssScrollPane.getParent();
//                    ssTableViewRowEditor.endEdit(true);
//                }
                return false;
            }
        });

        return tablePane;
    }
}
