/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.config.Location;
import jp.pegasus.pivot.ss.SSTextInput;
import jp.pegasus.util.JsonUtil;

public class SSTextInputFactory {

    public static SSTextInput createTextInput() {
        SSTextInput textArea = new SSTextInput();
        JsonUtil.setStyles(textArea, Location.TEXT_INPUT);

        return textArea;
    }

    public static void setDefault(SSTextInput textInput) {
        JsonUtil.setStyles(textInput, Location.TEXT_INPUT);
    }

    public static void setSelect(SSTextInput textInput) {
        JsonUtil.setStyles(textInput, Location.TEXT_INPUT_SELECT);
        textInput.setEnabled(true);
    }

    public static void setAlternate(SSTextInput textInput) {
        JsonUtil.setStyles(textInput, Location.TEXT_INPUT_ALTERNATE);
    }

}
