/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory;

import jp.pegasus.pivot.ss.SSTreeBranch;
import jp.pegasus.pivot.ss.SSTreeNode;

public class SSTreeBranchFactory {

    public static SSTreeBranch createTreeBranch(final String text, final SSTreeNode.NodeType nodeType, final Object userData) {
        SSTreeBranch treeBranch = new SSTreeBranch(text, nodeType) {{
            this.setUserData(userData);
        }};

        return treeBranch;
    }

//    public static SSTreeBranch createTreeBranch(Image icon, String text, SSTreeNode.NodeType nodeType, Object userData) {
//        SSTreeBranch treeBranch = new SSTreeBranch(icon, text, nodeType);
//        treeBranch.setUserData(userData);
//
//        return treeBranch;
//    }
//
//    public static SSTreeBranch createTreeBranch(Object userData) {
//        SSTreeBranch treeBranch = new SSTreeBranch();
//        treeBranch.setUserData(userData);
//
//        return treeBranch;
//    }
}
