/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.factory.tabpane;

import jp.pegasus.config.Location;
import jp.pegasus.pivot.factory.ScrollPaneFactory;
import jp.pegasus.pivot.factory.treeview.SSTreeViewOfWindowMenuFactory;
import jp.pegasus.pivot.skin.SSTabPaneSkin;
import jp.pegasus.pivot.ss.*;
import jp.pegasus.util.JsonUtil;
import org.apache.pivot.collections.ArrayList;
import org.apache.pivot.collections.Sequence;
import org.apache.pivot.wtk.ScrollPane;
import org.apache.pivot.wtk.content.ButtonData;

public class SSTabPaneMenuFactory {

    /**
     * Construct TabPane Menu
     *
     * @return
     */
    public static SSTabPane constructTabPaneMenu(ArrayList<SSTreeNode> treeNodeList, final int selectFileIndex) {
        SSTabPane tabPane = new SSTabPane();
        JsonUtil.setStyles(tabPane, Location.TAB_PANE_MU);

        SSTreeView treeView = SSTreeViewOfWindowMenuFactory.createTreeViewOfWindowMenu();
        treeView.setTreeData(treeNodeList);

        if (treeNodeList.getLength() != 0) {
            treeView.setSelectedPath(new Sequence.Tree.Path(selectFileIndex));
        }
        SSScrollPane scrollPane = ScrollPaneFactory.createScrollPane(ScrollPane.ScrollBarPolicy.AUTO, ScrollPane.ScrollBarPolicy.AUTO);
        scrollPane.setView(treeView);

        SSBorder border = new SSBorder();
        JsonUtil.setStyles(border, Location.BORDER_MU);
        border.setContent(scrollPane);

        SSTabPane.setTabData(border, new ButtonData(String.format("%-8s", "Projects")) {{
            setUserData(SSTabPaneSkin.Type.Menu);
        }});
        tabPane.getTabs().add(border);

        return tabPane;
    }

}
