/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.listener;


import jp.pegasus.pivot.media.SSDrawing;
import jp.pegasus.pivot.media.drawing.Canvas;

import java.awt.*;


/**
 * Drawing listener interface.
 */
public interface SSDrawingListener {
    /**
     * Called when a drawing's canvas has changed.
     *
     * @param drawing
     * @param previousCanvas
     */
    public void canvasChanged(SSDrawing drawing, Canvas previousCanvas);

    /**
     * Called when a drawing's background has changed.
     *
     * @param drawing
     * @param previousBackground
     */
    public void backgroundChanged(SSDrawing drawing, Paint previousBackground);
}
