/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.listener;

import jp.pegasus.pivot.ss.SSLabel;
import org.apache.pivot.wtk.BindType;

public interface SSLabelBindingListener {
    /**
     * Label binding listener adapter.
     */
    public static class Adapter implements SSLabelBindingListener {
        @Override
        public void textKeyChanged(SSLabel label, String previousTextKey) {
        }

        @Override
        public void textBindTypeChanged(SSLabel label, BindType previousTextBindType) {
        }

        @Override
        public void textBindMappingChanged(SSLabel label, SSLabel.TextBindMapping previousTextBindMapping) {
        }
    }

    /**
     * Called when a label's text key has changed.
     *
     * @param label
     * @param previousTextKey
     */
    public void textKeyChanged(SSLabel label, String previousTextKey);

    /**
     * Called when a label's text bind type has changed.
     *
     * @param label
     * @param previousTextBindType
     */
    public void textBindTypeChanged(SSLabel label, BindType previousTextBindType);

    /**
     * Called when a label's text bind mapping has changed.
     *
     * @param label
     * @param previousTextBindMapping
     */
    public void textBindMappingChanged(SSLabel label, SSLabel.TextBindMapping previousTextBindMapping);
}
