/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
package jp.pegasus.pivot.listener.drawing;

import jp.pegasus.pivot.media.drawing.Canvas;

/**
 * Canvas listener interface.
 */
public interface CanvasListener {
    /**
     * Called when a region within a canvas needs to be repainted.
     *
     * @param canvas
     * @param x
     * @param y
     * @param width
     * @param height
     */
    public void regionUpdated(Canvas canvas, int x, int y, int width, int height);

    /**
     * Called when a canvas has been invalidated.
     *
     * @param canvas
     */
    public void canvasInvalidated(Canvas canvas);
}
