/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
package jp.pegasus.pivot.listener.drawing;

import jp.pegasus.pivot.media.drawing.Shape;
import org.apache.pivot.collections.Sequence;

/**
 * Shape transform listener interface.
 */
public interface ShapeTransformListener {
    /**
     * Called when a transform has been inserted into a shape's transform
     * sequence.
     *
     * @param shape
     * @param index
     */
    public void transformInserted(Shape shape, int index);

    /**
     * Called when transforms have been removed from a shape's transform
     * sequence.
     *
     * @param shape
     * @param index
     * @param transforms
     */
    public void transformsRemoved(Shape shape, int index, Sequence<Shape.Transform> transforms);

    /**
     * Called when a transform has been updated in a shape's transform
     * sequence.
     *
     * @param transform
     */
    public void transformUpdated(Shape.Transform transform);
}
