/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.listener.tableview;

import jp.pegasus.pivot.ss.tableview.SSTableView;
import jp.pegasus.pivot.ss.tableview.SSTableViewHeader;

public interface SSTableViewHeaderListener {
    /**
     * Table view header listener adapter.
     */
    public static class Adapter implements SSTableViewHeaderListener {
        @Override
        public void tableViewChanged(SSTableViewHeader tableViewHeader, SSTableView previousTableView) {
        }

        @Override
        public void sortModeChanged(SSTableViewHeader tableViewHeader, SSTableViewHeader.SortMode previousSortMode) {
        }
    }

    /**
     * Called when a table view header's table view has changed.
     *
     * @param tableViewHeader
     * @param previousTableView
     */
    public void tableViewChanged(SSTableViewHeader tableViewHeader, SSTableView previousTableView);

    /**
     * Called when a table view header's sort mode has changed.
     *
     * @param tableViewHeader
     * @param previousSortMode
     */
    public void sortModeChanged(SSTableViewHeader tableViewHeader, SSTableViewHeader.SortMode previousSortMode);
}
