/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.listener.tabpane;

import jp.pegasus.pivot.ss.SSTabPane;
import org.apache.pivot.wtk.Component;

public interface SSTabPaneAttributeListener {
    /**
     * Tab pane attribute listener adapter.
     */
    public static class Adapter implements SSTabPaneAttributeListener {
        @Override
        public void tabDataChanged(SSTabPane tabPane, Component component, Object previousTabData) {
        }

        @Override
        public void tooltipTextChanged(SSTabPane tabPane, Component component, String previousTooltipText) {
        }
    }

    /**
     * Called when a tab's tab data attribute has changed.
     *
     * @param tabPane
     * @param component
     * @param previousTabData
     */
    public void tabDataChanged(SSTabPane tabPane, Component component, Object previousTabData);

    /**
     * Called when a tab's tooltipText attribute has changed.
     *
     * @param tabPane
     * @param component
     */
    public void tooltipTextChanged(SSTabPane tabPane, Component component, String previousTooltipText);
}
