/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.listener.textarea;

import jp.pegasus.pivot.ss.SSTextArea;

public interface SSTextAreaListener {
    /**
     * Text area listener adapter.
     */
    public static class Adapter implements SSTextAreaListener {
        @Override
        public void maximumLengthChanged(SSTextArea textArea, int previousMaximumLength) {
        }

        @Override
        public void editableChanged(SSTextArea textArea) {
        }
    }

    /**
     * Called when a text area's maximum length has changed.
     *
     * @param textArea
     * @param previousMaximumLength
     */
    public void maximumLengthChanged(SSTextArea textArea, int previousMaximumLength);

    /**
     * Called when a text area's editable state has changed.
     *
     * @param textArea
     */
    public void editableChanged(SSTextArea textArea);
}
