/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.listener.textinput;

import jp.pegasus.pivot.ss.SSTextInput;

public interface SSTextInputSelectionListener {
    /**
     * Called when a text input's selection state has changed.
     *
     * @param textInput               The source of the event.
     * @param previousSelectionStart  If the selection changed directly, the previous selection start index.
     *                                Otherwise, the current selection start index.
     * @param previousSelectionLength If the selection changed directly, the previous selection length.
     *                                Otherwise, the current selection length.
     */
    public void selectionChanged(SSTextInput textInput, int previousSelectionStart,
                                 int previousSelectionLength);
}
