/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.skin;

import jp.pegasus.pivot.ss.SSDisplay;
import org.apache.pivot.wtk.Dimensions;
import org.apache.pivot.wtk.Window;
import org.apache.pivot.wtk.skin.ContainerSkin;

import java.awt.*;

public class SSDisplaySkin extends ContainerSkin {
    public SSDisplaySkin() {
        super();
        setBackgroundColor(Color.LIGHT_GRAY);
    }

    @Override
    public void install(org.apache.pivot.wtk.Component component) {
        if (!(component instanceof SSDisplay)) {
            throw new IllegalArgumentException("SSDisplaySkin can only be installed on instances of Display.");
        }

        super.install(component);
    }

    @Override
    public void layout() {
        SSDisplay display = (SSDisplay) getComponent();

        // Set all components to their preferred sizes
        for (org.apache.pivot.wtk.Component component : display) {
            Window window = (Window) component;

            if (window.isVisible()) {
                if (window.isMaximized()) {
                    window.setSize(display.getSize());
                } else {
                    Dimensions preferredSize = window.getPreferredSize();

                    if (window.getWidth() != preferredSize.width
                    || window.getHeight() != preferredSize.height) {
                        window.setSize(preferredSize.width, preferredSize.height);
                    }
                }
            }
        }
    }
}

