/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.skin;

import jp.pegasus.pivot.ss.SSPalette;
import org.apache.pivot.collections.Dictionary;
import org.apache.pivot.util.Vote;
import org.apache.pivot.wtk.*;
import org.apache.pivot.wtk.Window;
import org.apache.pivot.wtk.effects.DropShadowDecorator;
import org.apache.pivot.wtk.effects.Transition;
import org.apache.pivot.wtk.effects.TransitionListener;
import org.apache.pivot.wtk.media.Image;
import org.apache.pivot.wtk.skin.WindowSkin;
import org.apache.pivot.wtk.skin.terra.FadeWindowTransition;
import org.apache.pivot.wtk.skin.terra.TerraTheme;

import java.awt.*;

public class SSPaletteSkin extends WindowSkin {
//    /**
//     * Close button image.
//     */
//    protected class CloseImage extends Image {
//        @Override
//        public int getWidth() {
//            return 6;
//        }
//
//        @Override
//        public int getHeight() {
//            return 6;
//        }
//
//        @Override
//        public void paint(Graphics2D graphics) {
////            graphics.setPaint(titleBarColor);
//            graphics.setStroke(new BasicStroke(2));
//
//            graphics.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
//                    RenderingHints.VALUE_ANTIALIAS_ON);
//
//            graphics.draw(new Line2D.Double(0.5, 0.5, 5.5, 5.5));
//            graphics.draw(new Line2D.Double(0.5, 5.5, 5.5, 0.5));
//        }
//    }

    /**
     * Resize button image.
     */
    protected class ResizeImage extends Image {
        public static final int ALPHA = 64;

        @Override
        public int getWidth() {
            return 5;
        }

        @Override
        public int getHeight() {
            return 5;
        }

        @Override
        public void paint(Graphics2D graphics) {
            graphics.setPaint(new Color(0, 0, 0, ALPHA));
            graphics.fillRect(3, 0, 2, 1);
            graphics.fillRect(0, 3, 2, 1);
            graphics.fillRect(3, 3, 2, 1);

            graphics.setPaint(new Color(contentBorderColor.getRed(),
            contentBorderColor.getGreen(), contentBorderColor.getBlue(),
            ALPHA));
            graphics.fillRect(3, 1, 2, 1);
            graphics.fillRect(0, 4, 2, 1);
            graphics.fillRect(3, 4, 2, 1);
        }
    }

    //    private Image closeImage = new CloseImage();
    private Image resizeImage = new ResizeImage();

//    private TablePane titleBarTablePane = new TablePane();
//    private BoxPane titleBoxPane = new BoxPane();
//    private BoxPane buttonBoxPane = new BoxPane();

    //    private org.apache.pivot.wtk.Label titleLabel = new org.apache.pivot.wtk.Label();
//    private LinkButton closeButton = new LinkButton(closeImage);
    private ImageView resizeHandle = new ImageView(resizeImage);

    private DropShadowDecorator dropShadowDecorator = null;

    private org.apache.pivot.wtk.Point dragOffset = null;
    private org.apache.pivot.wtk.Point resizeOffset = null;

    private org.apache.pivot.wtk.Insets padding = new org.apache.pivot.wtk.Insets(1);

//    private SSWindowClassListener windowClassListener = new SSWindowClassListener() {
//        @Override
//        public void activeWindowChanged(SSWindow previousActiveWindow) {
//            SSPalette palette = (SSPalette) getComponent();
//            SSWindow owner = palette.getOwner();
//
//            SSWindow activeWindow = SSWindow.getActiveWindow();
//            palette.setVisible(activeWindow != null
//                    && (owner == activeWindow
//                    || owner.isOwner(activeWindow)));
//        }
//    };

    //    private Color titleBarColor;
//    private Color titleBarBackgroundColor;
//    private Color titleBarBorderColor;
    private Color contentBorderColor;

    // Derived colors
//    private Color titleBarBevelColor;
    private Color contentBevelColor;

    private Transition closeTransition = null;
    private int closeTransitionDuration = DEFAULT_CLOSE_TRANSITION_DURATION;
    private int closeTransitionRate = DEFAULT_CLOSE_TRANSITION_RATE;
    private static final int DEFAULT_CLOSE_TRANSITION_DURATION = 250;
    private static final int DEFAULT_CLOSE_TRANSITION_RATE = 30;

    public SSPaletteSkin() {
        TerraTheme theme = (TerraTheme) Theme.getTheme();
        setBackgroundColor(theme.getColor(10));

//        titleBarColor = theme.getColor(4);
//        titleBarBackgroundColor = theme.getColor(14);
//        titleBarBorderColor = theme.getColor(12);
        contentBorderColor = theme.getColor(7);

        // Set the derived colors
//        titleBarBevelColor = TerraTheme.brighten(titleBarBackgroundColor);

        // The title bar table pane contains two nested box panes: one for
        // the title contents and the other for the buttons
//        titleBarTablePane.getColumns().add(new TablePane.Column(1, true));
//        titleBarTablePane.getColumns().add(new TablePane.Column(-1));

//        TablePane.Row titleRow = new TablePane.Row(-1);
//        titleBarTablePane.getRows().add(titleRow);

//        titleRow.add(titleBoxPane);
//        titleRow.add(buttonBoxPane);

//        titleBarTablePane.getStyles().put("padding", new org.apache.pivot.wtk.Insets(2, 3, 2, 3));

        // Initialize the title box pane
//        titleBoxPane.getStyles().put("verticalAlignment", VerticalAlignment.CENTER);
//        titleBoxPane.add(titleLabel);
//        titleBoxPane.getStyles().put("padding", new org.apache.pivot.wtk.Insets(0, 0, 0, 3));

//        Font titleFont = theme.getFont();
//        titleFont = titleFont.deriveFont(Font.BOLD, Math.round(titleFont.getSize2D() * 0.8f));
//        titleLabel.getStyles().put("font", titleFont);
//        titleLabel.getStyles().put("color", titleBarColor);

        // Initialize the button box pane
//        buttonBoxPane.getStyles().put("horizontalAlignment", HorizontalAlignment.RIGHT);
//        buttonBoxPane.getStyles().put("verticalAlignment", VerticalAlignment.CENTER);
//        buttonBoxPane.add(closeButton);

//        closeButton.getComponentMouseButtonListeners().add(new ComponentMouseButtonListener.Adapter() {
//            @Override
//            public boolean mouseDown(org.apache.pivot.wtk.Component component, Mouse.Button button, int x, int y) {
//                // Consume the event so we don't process it as a click on
//                // the title bar and try to move the window
//                return true;
//            }
//        });

//        closeButton.getButtonPressListeners().add(new ButtonPressListener() {
//            @Override
//            public void buttonPressed(org.apache.pivot.wtk.Button button) {
//                SSPalette palette = (SSPalette) getComponent();
//                palette.close();
//            }
//        });
    }

    public int getCloseTransitionDuration() {
        return closeTransitionDuration;
    }

    public void setCloseTransitionDuration(int closeTransitionDuration) {
        this.closeTransitionDuration = closeTransitionDuration;
    }

    public int getCloseTransitionRate() {
        return closeTransitionRate;
    }

    public void setCloseTransitionRate(int closeTransitionRate) {
        this.closeTransitionRate = closeTransitionRate;
    }

    @Override
    public Vote previewWindowClose(final Window window) {
        Vote vote = Vote.APPROVE;

        if (closeTransition == null) {
            closeTransition = new FadeWindowTransition(window, closeTransitionDuration,
            closeTransitionRate, dropShadowDecorator);

            closeTransition.start(new TransitionListener() {
                @Override
                public void transitionCompleted(Transition transition) {
                    window.close();
                }
            });

            vote = Vote.DEFER;
        } else {
            vote = (closeTransition.isRunning()) ? Vote.DEFER : Vote.APPROVE;
        }

        return vote;
    }

    @Override
    public void windowCloseVetoed(Window window, Vote reason) {
        super.windowCloseVetoed(window, reason);

        if (reason == Vote.DENY
        && closeTransition != null) {
            closeTransition.stop();
        }
    }

    @Override
    public void install(org.apache.pivot.wtk.Component component) {
        super.install(component);

        SSPalette palette = (SSPalette) component;
//        palette.add(titleBarTablePane);

        // Attach the drop-shadow decorator
        dropShadowDecorator = new DropShadowDecorator(3, 3, 3);
        palette.getDecorators().add(dropShadowDecorator);

        palette.add(resizeHandle);

        titleChanged(palette, null);
    }

    @Override
    public int getPreferredWidth(int height) {
        int preferredWidth = 0;

        SSPalette palette = (SSPalette) getComponent();
        org.apache.pivot.wtk.Component content = palette.getContent();

//        Dimensions preferredTitleBarSize = titleBarTablePane.getPreferredSize();
//        preferredWidth = preferredTitleBarSize.width;

        if (content != null) {
//            if (height != -1) {
//                height = Math.max(height - preferredTitleBarSize.height - 4 -
//                        padding.top - padding.bottom, 0);
//            }

            preferredWidth = Math.max(preferredWidth,
            content.getPreferredWidth(height));
        }

        preferredWidth += (padding.left + padding.right) + 2;

        return preferredWidth;
    }

    @Override
    public int getPreferredHeight(int width) {
        int preferredHeight = 0;

        SSPalette palette = (SSPalette) getComponent();
        org.apache.pivot.wtk.Component content = palette.getContent();

        if (width != -1) {
            width = Math.max(width - 2, 0);
        }

//        preferredHeight = titleBarTablePane.getPreferredHeight(width);

        if (content != null) {
            if (width != -1) {
                width = Math.max(width - padding.left - padding.right, 0);
            }

            preferredHeight += content.getPreferredHeight(width);
        }

//        preferredHeight += (padding.top + padding.bottom) + 4;
        preferredHeight += (padding.top + padding.bottom) + 2;

        return preferredHeight;
    }

    @Override
    public Dimensions getPreferredSize() {
        int preferredWidth = 0;
        int preferredHeight = 0;

        SSPalette palette = (SSPalette) getComponent();
        org.apache.pivot.wtk.Component content = palette.getContent();

//        Dimensions preferredTitleBarSize = titleBarTablePane.getPreferredSize();
//        preferredWidth = preferredTitleBarSize.width;
//        preferredHeight = preferredTitleBarSize.height;

        if (content != null) {
            Dimensions preferredContentSize = content.getPreferredSize();

            preferredWidth = Math.max(preferredWidth, preferredContentSize.width);
            preferredHeight += preferredContentSize.height;
        }

        preferredWidth += (padding.left + padding.right) + 2;
//        preferredHeight += (padding.top + padding.bottom) + 4;
        preferredHeight += (padding.top + padding.bottom) + 2;

        return new Dimensions(preferredWidth, preferredHeight);
    }

    @Override
    public void layout() {
        SSPalette palette = (SSPalette) getComponent();

        int width = getWidth();
        int height = getHeight();

//        int clientX = 1;
//        int clientY = 1;
        int clientWidth = Math.max(width - 2, 0);
        int clientHeight = Math.max(height - 2, 0);

        // Size/position title bar
//        titleBarTablePane.setLocation(clientX, clientY);
//        titleBarTablePane.setSize(clientWidth, titleBarTablePane.getPreferredHeight());

        // Size/position resize handle
        resizeHandle.setSize(resizeHandle.getPreferredSize());
        resizeHandle.setLocation(clientWidth - resizeHandle.getWidth(),
        clientHeight - resizeHandle.getHeight());
        resizeHandle.setVisible(palette.isPreferredWidthSet()
        || palette.isPreferredHeightSet());

        // Size/position content
        org.apache.pivot.wtk.Component content = palette.getContent();

        if (content != null) {
//            content.setLocation(padding.left + 1,
//                    titleBarTablePane.getHeight() + padding.top + 3);
            content.setLocation(padding.left + 1, padding.top + 1);

            final int contentWidth = Math.max(width - (padding.left + padding.right + 2), 0);
//            int contentHeight = Math.max(height - (titleBarTablePane.getHeight()
//                    + padding.top + padding.bottom + 4), 0);
//            int contentHeight = Math.max(height - (padding.top + padding.bottom + 4), 0);
            final int contentHeight = Math.max(height - (padding.top + padding.bottom + 2), 0);

            content.setSize(contentWidth, contentHeight);
        }
    }

    @Override
    public void paint(Graphics2D graphics) {
        // Call the base class to paint the background
        super.paint(graphics);

        final int width = getWidth();
        final int height = getHeight();
//        int titleBarHeight = titleBarTablePane.getHeight();

        graphics.setStroke(new BasicStroke());

        // Draw the title area
//        graphics.setPaint(new GradientPaint(width / 2f, 0, titleBarBevelColor,
//                width / 2f, titleBarHeight + 1, titleBarBackgroundColor));
//        graphics.fillRect(0, 0, width, titleBarHeight + 1);

        // Draw the border
//        graphics.setPaint(titleBarBorderColor);
//        GraphicsUtilities.drawRect(graphics, 0, 0, width, titleBarHeight + 1);
//        GraphicsUtilities.drawRect(graphics, 0, 0, width, 1);
        // Draw the content area
//        Bounds contentAreaRectangle = new Bounds(0, titleBarHeight + 2,
//                width, height - (titleBarHeight + 2));
//        Bounds contentAreaRectangle = new Bounds(0, 2, width, height - 2);
//        Bounds contentAreaRectangle = new Bounds(0, 0, width, height);
        graphics.setPaint(contentBorderColor);
//        GraphicsUtilities.drawRect(graphics, contentAreaRectangle.x, contentAreaRectangle.y,
//                contentAreaRectangle.width, contentAreaRectangle.height);
        GraphicsUtilities.drawRect(graphics, 0, 0, width, height);

        graphics.setPaint(contentBevelColor);
//        GraphicsUtilities.drawLine(graphics, contentAreaRectangle.x + 1,
//                contentAreaRectangle.y + 1, contentAreaRectangle.width - 2, Orientation.HORIZONTAL);
        GraphicsUtilities.drawLine(graphics, 1, 1, width - 2, Orientation.HORIZONTAL);
    }

    @Override
    public Bounds getClientArea() {
        final int width = getWidth();
        final int height = getHeight();
//        int titleBarHeight = titleBarTablePane.getHeight();

//        return new Bounds(0, titleBarHeight + 2, width, height - (titleBarHeight + 2));
        return new Bounds(0, 2, width, height - 2);
    }

    @Override
    public void setBackgroundColor(Color backgroundColor) {
        super.setBackgroundColor(backgroundColor);
        contentBevelColor = TerraTheme.brighten(backgroundColor);
    }

    public org.apache.pivot.wtk.Insets getPadding() {
        return padding;
    }

    public void setPadding(org.apache.pivot.wtk.Insets padding) {
        if (padding == null) {
            throw new IllegalArgumentException("padding is null.");
        }

        this.padding = padding;
        invalidateComponent();
    }

    public final void setPadding(Dictionary<String, ?> padding) {
        if (padding == null) {
            throw new IllegalArgumentException("padding is null.");
        }

        setPadding(new org.apache.pivot.wtk.Insets(padding));
    }

    public final void setPadding(int padding) {
        setPadding(new org.apache.pivot.wtk.Insets(padding));
    }

    public final void setPadding(Number padding) {
        if (padding == null) {
            throw new IllegalArgumentException("padding is null.");
        }

        setPadding(padding.intValue());
    }

    public final void setPadding(String padding) {
        if (padding == null) {
            throw new IllegalArgumentException("padding is null.");
        }

        setPadding(org.apache.pivot.wtk.Insets.decode(padding));
    }

    @Override
    public boolean mouseMove(org.apache.pivot.wtk.Component component, int x, int y) {
        boolean consumed = super.mouseMove(component, x, y);

        if (Mouse.getCapturer() == component) {
            SSPalette palette = (SSPalette) getComponent();
            Display display = palette.getDisplay();

            org.apache.pivot.wtk.Point location = palette.mapPointToAncestor(display, x, y);

            // Pretend that the mouse can't move off screen (off the display)
            location = new org.apache.pivot.wtk.Point(Math.min(Math.max(location.x, 0), display.getWidth() - 1),
            Math.min(Math.max(location.y, 0), display.getHeight() - 1));

            if (dragOffset != null) {
                // Move the window
                palette.setLocation(location.x - dragOffset.x, location.y - dragOffset.y);
            } else {
                if (resizeOffset != null) {
                    // Resize the frame
                    int preferredWidth = -1;
                    int preferredHeight = -1;

                    if (palette.isPreferredWidthSet()) {
//                        preferredWidth = Math.max(location.x - palette.getX() + resizeOffset.x,
//                                titleBarTablePane.getPreferredWidth(-1) + 2);
                        preferredWidth = Math.max(location.x - palette.getX() + resizeOffset.x, 2);
                        preferredWidth = Math.min(preferredWidth, palette.getMaximumWidth());
                        preferredWidth = Math.max(preferredWidth, palette.getMinimumWidth());
                    }

                    if (palette.isPreferredHeightSet()) {
//                        preferredHeight = Math.max(location.y - palette.getY() + resizeOffset.y,
//                                titleBarTablePane.getHeight() + resizeHandle.getHeight() + 7);
                        preferredHeight = Math.max(location.y - palette.getY() + resizeOffset.y, resizeHandle.getHeight() + 7);
                        preferredHeight = Math.min(preferredHeight, palette.getMaximumHeight());
                        preferredHeight = Math.max(preferredHeight, palette.getMinimumHeight());
                    }

                    palette.setPreferredSize(preferredWidth, preferredHeight);
                }
            }
        } else {
            org.apache.pivot.wtk.Cursor cursor = null;
            if (resizeHandle.isVisible()
            && x > resizeHandle.getX()
            && y > resizeHandle.getY()) {
                boolean preferredWidthSet = component.isPreferredWidthSet();
                boolean preferredHeightSet = component.isPreferredHeightSet();

                if (preferredWidthSet
                && preferredHeightSet) {
                    cursor = org.apache.pivot.wtk.Cursor.RESIZE_SOUTH_EAST;
                } else if (preferredWidthSet) {
                    cursor = org.apache.pivot.wtk.Cursor.RESIZE_EAST;
                } else if (preferredHeightSet) {
                    cursor = org.apache.pivot.wtk.Cursor.RESIZE_SOUTH;
                }
            }

            component.setCursor(cursor);
        }

        return consumed;
    }

    @Override
    public boolean mouseDown(org.apache.pivot.wtk.Component component, Mouse.Button button, int x, int y) {
        boolean consumed = super.mouseDown(component, button, x, y);

        org.apache.pivot.wtk.Window window = (org.apache.pivot.wtk.Window) getComponent();
        boolean maximized = window.isMaximized();

        if (button == Mouse.Button.LEFT
        && !maximized) {
//            Bounds titleBarBounds = titleBarTablePane.getBounds();

//            if (titleBarBounds.contains(x, y)) {
//                dragOffset = new org.apache.pivot.wtk.Point(x, y);
//                Mouse.capture(component);
//            } else {
//                Bounds resizeHandleBounds = resizeHandle.getBounds();
//
//                if (resizeHandleBounds.contains(x, y)) {
//                    resizeOffset = new org.apache.pivot.wtk.Point(getWidth() - x, getHeight() - y);
//                    Mouse.capture(component);
//                }
//            }
            Bounds resizeHandleBounds = resizeHandle.getBounds();

            if (resizeHandleBounds.contains(x, y)) {
                resizeOffset = new org.apache.pivot.wtk.Point(getWidth() - x, getHeight() - y);
                Mouse.capture(component);
            }
        }

        return consumed;
    }

    @Override
    public boolean mouseUp(org.apache.pivot.wtk.Component component, Mouse.Button button, int x, int y) {
        boolean consumed = super.mouseUp(component, button, x, y);

        if (Mouse.getCapturer() == component) {
            dragOffset = null;
            resizeOffset = null;
            Mouse.release();
        }

        return consumed;
    }

    @Override
    public void titleChanged(Window window, String previousTitle) {
        super.titleChanged(window, previousTitle);

//        String title = window.getTitle();
//        titleLabel.setVisible(title != null);
//        titleLabel.setText(title);
    }

//    @Override
//    public void windowOpened(Window window) {
//        super.windowOpened(window);
//
//        Window.getWindowClassListeners().add(windowClassListener);
//    }
//
//    @Override
//    public void windowClosed(SSWindow window, Display display, Window owner) {
//        super.windowClosed(window, display, owner);
//
//        closeTransition = null;
//        Window.getWindowClassListeners().remove(windowClassListener);
//    }
}
