/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.ss;

import org.apache.pivot.collections.HashMap;
import org.apache.pivot.wtk.Component;

public class SSAutomation {
    private SSAutomation() {
    }

    private static HashMap<String, Component> components = new HashMap<String, Component>();

    public static Component get(String automationID) {
        return components.get(automationID);
    }

    protected static void add(String automationID, Component component) {
        components.put(automationID, component);
    }

    protected static void remove(String automationID) {
        components.remove(automationID);
    }
}

