/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.ss;

import org.apache.pivot.wtk.Component;
import org.apache.pivot.wtk.Window;

public class SSPalette extends Window {

    public enum Type {
        Default,
        PopupSpreadSheet,
        PopupWindowMenu,
        PopupTabPane,
    }

    private Type paletteType = Type.Default;

    public SSPalette() {
        this(null, null, null);
    }

    public SSPalette(Type type) {
        this(type, null, null);
    }

    public SSPalette(String title) {
        this(Type.Default, title, null);
    }

    public SSPalette(Component content) {
        this(Type.Default, null, content);
    }

    public SSPalette(Type type, String title, Component content) {
        super(content);
        setPaletteType(type);
        setTitle(title);
        installSkin(SSPalette.class);
    }

    public Type getPaletteType() {
        return paletteType;
    }

    public void setPaletteType(Type paletteType) {
        this.paletteType = paletteType;
    }

    //    @Override
//    public void open(Display display, SSWindow owner) {
//        if (owner == null) {
//            throw new IllegalStateException("Palettes must have an owner.");
//        }
//
//        super.open(display, owner);
//    }
}
