/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.ss;

import jp.pegasus.pivot.skin.ScrollPaneSkin;
import org.apache.pivot.wtk.Component;
import org.apache.pivot.wtk.Mouse.Button;
import org.apache.pivot.wtk.ScrollPane;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class SSScrollPane extends ScrollPane {
    private static Logger log = LoggerFactory.getLogger(SSScrollPane.class);

    int currentScrollIndex = 0x00000000;

    public SSScrollPane() {
        this(ScrollBarPolicy.AUTO, ScrollBarPolicy.AUTO);
    }

    public SSScrollPane(ScrollBarPolicy horizontalScrollBarPolicy,
                        ScrollBarPolicy verticalScrollBarPolicy) {
        super(horizontalScrollBarPolicy, verticalScrollBarPolicy);
        setSkin(new ScrollPaneSkin());
    }

    @Override
    protected void setSkin(org.apache.pivot.wtk.Skin skin) {
        super.setSkin(skin);
    }

    @Override
    public void setColumnHeader(Component columnHeader) {
        //log.debug(columnHeader.toString());
        super.setColumnHeader(columnHeader);
    }

    @Override
    public void setCorner(Component corner) {
        //log.debug(corner.toString());
        super.setCorner(corner);
    }

    @Override
    public void setScrollTop(int scrollTop) {
//		log.debug("scrollTop:{}", scrollTop);
        super.setScrollTop(scrollTop);
    }

    @Override
    public void setScrollLeft(int scrollLeft) {
//		log.debug("scrollLeft:{}", scrollLeft);
        super.setScrollLeft(scrollLeft);
    }

    @Override
    protected boolean mouseDown(Button button, int x, int y) {
//        log.debug(button.toString());
        return super.mouseDown(button, x, y);
    }


}
