/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.ss.tablepane;

import jp.pegasus.pivot.skin.SSTablePaneSkin;
import jp.pegasus.pivot.ss.SSCorner;
import org.apache.pivot.wtk.Renderer;
import org.apache.pivot.wtk.TablePane;

public class SSTablePane extends TablePane {
    public static final class SSCornerHeader extends SSCorner {
        public SSCornerHeader() {
            super();
        }
    }

    public interface CellRenderer extends Renderer {
        public void render(Object row, int rowIndex, int columnIndex,
                           SSTablePane ssTablePane, String columnName,
                           boolean selected, boolean highlighted, boolean disabled);

        public String toString(Object row, String columnName);
    }

    public static class SSRow extends TablePane.Row {
        @Override
        public int getHeight() {
            return super.getHeight();
        }

        @Override
        public void setHeight(int height) {
            super.setHeight(height);
        }

    }

    public static class SSColumn extends TablePane.Column {
        @Override
        public int getWidth() {
            return super.getWidth();
        }

        @Override
        public void setWidth(int width) {
            super.setWidth(width);
        }
    }

    public SSTablePane() {
        super();
        setSkin(new SSTablePaneSkin());
    }

    @Override
    protected void setSkin(org.apache.pivot.wtk.Skin skin) {
        super.setSkin(skin);
    }

}
