/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.ss.tablepane;

import jp.pegasus.deprecated.SSTablePaneHeaderListener;
import jp.pegasus.pivot.skin.SSTablePaneHeaderSkin;
import org.apache.pivot.util.ListenerList;
import org.apache.pivot.wtk.Component;
import org.apache.pivot.wtk.Orientation;

public class SSTablePaneHeader extends Component {

    private static class SSTablePaneHeaderListenerList
    extends ListenerList<SSTablePaneHeaderListener> implements SSTablePaneHeaderListener {

        public void orientationChanged(SSTablePaneHeader ssTablePaneHeader) {
            for (SSTablePaneHeaderListener listener : this) {
                listener.orientationChanged(ssTablePaneHeader);
            }
        }
    }

    private SSTablePane ssTablePane;
    private Orientation orientation;

    private SSTablePaneHeaderListenerList ssTablePaneHeaderListeners = new SSTablePaneHeaderListenerList();

    public SSTablePaneHeader() {
        setSkin(new SSTablePaneHeaderSkin());
    }

    public Orientation getOrientation() {
        return orientation;
    }

    public void setOrientation(Orientation orientation) {
        if (orientation == null) {
            throw new IllegalArgumentException();
        }

        if (this.orientation != orientation) {
            this.orientation = orientation;
            ssTablePaneHeaderListeners.orientationChanged(this);
        }
    }

    public void setOrientation(String orientation) {
        if (orientation == null) {
            throw new IllegalArgumentException();
        }

        setOrientation(Orientation.valueOf(orientation.toUpperCase()));
    }

    public ListenerList<SSTablePaneHeaderListener> getSSTablePaneHeaderListeners() {
        return ssTablePaneHeaderListeners;
    }

    public void setSSTablePane(SSTablePane ssTablePane) {
        this.ssTablePane = ssTablePane;
    }

    public SSTablePane getSSTablePane() {
        return ssTablePane;
    }


}
