/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.pivot.util;

import jp.pegasus.config.Config;
import jp.pegasus.log.Logger;
import jp.pegasus.pivot.model.*;
import jp.pegasus.pivot.skin.SSTabPaneSkin;
import jp.pegasus.pivot.ss.SSTabPane;
import jp.pegasus.util.JsonUtil;
import org.apache.pivot.collections.ArrayList;
import org.apache.pivot.collections.HashMap;
import org.apache.pivot.wtk.Window;

import java.io.File;

public class SSTabPaneUtil {

    @SuppressWarnings("unchecked")
    public static void delete(SSTabPaneSkin.TabButton tabButton) {
        Logger.log.debug("tabButton:{}", tabButton.toString());

        // todo null pointer exception
        SSTabPane tabPane = (SSTabPane) ((tabButton.getParent()).getParent()).getParent();
        Window window = tabPane.getWindow();
        if (window != null) {
            SSData data = (SSData) window.getAttribute(SSData.DEFAULT_TYPE);
            final int selectFileIndex = data.getSelectFileIndex();
            SSFileData selectFileData = data.getFileDataList().get(selectFileIndex);
            final int selectSheetIndex = selectFileData.getSelectSheetIndex();
            selectFileData.getSheetDataList().remove(selectSheetIndex, 1);

            /**
             * Remove Tab
             */
            final int selectedTabIndex = tabPane.getSelectedIndex();
            tabPane.getTabs().remove(selectedTabIndex, 1);

            /**
             * Display Tab
             */
            final int newSelectedTabIndex = selectedTabIndex == 0 ? 0 : selectedTabIndex - 1;
            tabPane.setSelectedIndex(newSelectedTabIndex);
            selectFileData.setSelectSheetIndex(newSelectedTabIndex);
            Object sheetData = selectFileData.getSheetDataList().get(newSelectedTabIndex);
            if (sheetData instanceof HashMap) {
                // todo

            } else if (sheetData instanceof SSGridData) {
                String cellDataDigest = ((SSGridData) sheetData).getCellDataDigest();
                ArrayList<HashMap<String, SSElementalData>> cellDataList = null;
                if (cellDataDigest == null) {
                    cellDataList = SSElementalData.createCellDataList();

                    String newDigest = JsonUtil.getDigest(cellDataList, Config.DIGEST_ARGORITHM);
                    StringBuilder cellDataFilePath = new StringBuilder(Config.APP_CELL_DATA_DIR).append(File.separator).append(newDigest);
                    JsonUtil.writeSheetData(cellDataList, cellDataFilePath.toString());
                    ((SSGridData) sheetData).setCellDataDigest(newDigest);
                }
//                else {
//                    String cellDataFilePath = Config.APP_CELL_DATA_DIR + File.separator + cellDataDigest;
//                    cellDataList = JsonUtil.readCellDataList(cellDataFilePath);
//                }
            } else if (sheetData instanceof SSTextData) {
                String textDataDigest = ((SSTextData) sheetData).getTextDataDigest();
                SSElementalData elementalData = null;
                if (textDataDigest == null) {
                    elementalData = new SSElementalData();
                    String newDigest = JsonUtil.getDigest(elementalData, Config.DIGEST_ARGORITHM);
                    StringBuilder textDataFilePath = new StringBuilder(Config.APP_TEXT_DATA_DIR).append(File.separator).append(newDigest);
                    JsonUtil.writeSheetData(elementalData, textDataFilePath.toString());
                    ((SSTextData) sheetData).setTextDataDigest(newDigest);
                }
//                else {
//                    String textDataFilePath = Config.APP_TEXT_DATA_DIR + File.separator + textDataDigest;
//                    elementalData = JsonUtil.readTextData(textDataFilePath);
//                }
            } else {
                throw new RuntimeException();
            }

        }
    }

}
