/*
 * Copyright (C) 2010-2011 Toshiyuki Kitani
 *
 *  Pegasus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Pegasus is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package jp.pegasus.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class DigestUtil {

    /**
     * Generate Digest
     *
     * @param data
     * @param algorithm
     * @return
     */
    public static byte[] generateDigest(String data, String algorithm) {
        MessageDigest md;
        try {
            md = MessageDigest.getInstance(algorithm);
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }

        md.update(data.getBytes());
        byte[] digest = md.digest();
//        Logger.log.debug("digest: {}", digest);

        return digest;
    }


    /**
     * Get String Digest
     *
     * @param digest
     * @return
     */
    public static String getStringDigest(byte[] digest) {
        StringBuilder digestBuilder = new StringBuilder();
        for (int i = 0, len = digest.length; i < len; i++) {
            int d = digest[i];
            if (d < 0) {
                d += 256;
            }
            if (d < 16) {
                digestBuilder.append("0");
            }
            digestBuilder.append(Integer.toString(d, 16));
        }
        return digestBuilder.toString();
    }

}
